"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MeshTLSAuthentication = void 0;
const IoK8sApimachineryPkgApisMetaV1ObjectMeta_1 = require("@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta");
const base_1 = require("@kubernetes-models/base");
const validate_1 = require("@kubernetes-models/validate");
const schemaId = "policy.linkerd.io.v1alpha1.MeshTLSAuthentication";
const schema = {
    "type": "object",
    "properties": {
        "spec": {
            "type": "object",
            "oneOf": [
                {
                    "required": [
                        "identities"
                    ]
                },
                {
                    "required": [
                        "identityRefs"
                    ]
                }
            ],
            "properties": {
                "identities": {
                    "type": "array",
                    "minItems": 1,
                    "items": {
                        "type": "string",
                        "pattern": "^(\\*|[a-z0-9]([-a-z0-9]*[a-z0-9])?)(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$"
                    },
                    "nullable": true
                },
                "identityRefs": {
                    "type": "array",
                    "minItems": 1,
                    "items": {
                        "type": "object",
                        "required": [
                            "kind"
                        ],
                        "properties": {
                            "group": {
                                "maxLength": 253,
                                "type": "string",
                                "pattern": "^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$",
                                "nullable": true
                            },
                            "kind": {
                                "maxLength": 63,
                                "minLength": 1,
                                "type": "string",
                                "pattern": "^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$"
                            },
                            "name": {
                                "maxLength": 253,
                                "minLength": 1,
                                "type": "string",
                                "nullable": true
                            },
                            "namespace": {
                                "maxLength": 253,
                                "type": "string",
                                "nullable": true
                            }
                        }
                    },
                    "nullable": true
                }
            }
        },
        "apiVersion": {
            "type": "string",
            "enum": [
                "policy.linkerd.io/v1alpha1"
            ]
        },
        "kind": {
            "type": "string",
            "enum": [
                "MeshTLSAuthentication"
            ]
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        }
    },
    "required": [
        "spec",
        "apiVersion",
        "kind"
    ]
};
class MeshTLSAuthentication extends base_1.Model {
    constructor(data) {
        super({
            apiVersion: MeshTLSAuthentication.apiVersion,
            kind: MeshTLSAuthentication.kind,
            ...data
        });
    }
}
exports.MeshTLSAuthentication = MeshTLSAuthentication;
MeshTLSAuthentication.apiVersion = "policy.linkerd.io/v1alpha1";
MeshTLSAuthentication.kind = "MeshTLSAuthentication";
MeshTLSAuthentication.is = (0, base_1.createTypeMetaGuard)(MeshTLSAuthentication);
(0, base_1.setSchema)(MeshTLSAuthentication, schemaId, () => {
    (0, IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.addSchema)();
    (0, validate_1.register)(schemaId, schema);
});
