import { addSchema } from "@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta";
import { Model, setSchema, createTypeMetaGuard } from "@kubernetes-models/base";
import { register } from "@kubernetes-models/validate";
const schemaId = "policy.linkerd.io.v1alpha1.NetworkAuthentication";
const schema = {
    "type": "object",
    "properties": {
        "spec": {
            "type": "object",
            "required": [
                "networks"
            ],
            "properties": {
                "networks": {
                    "type": "array",
                    "items": {
                        "type": "object",
                        "required": [
                            "cidr"
                        ],
                        "properties": {
                            "cidr": {
                                "type": "string"
                            },
                            "except": {
                                "type": "array",
                                "items": {
                                    "type": "string"
                                },
                                "nullable": true
                            }
                        }
                    }
                }
            }
        },
        "apiVersion": {
            "type": "string",
            "enum": [
                "policy.linkerd.io/v1alpha1"
            ]
        },
        "kind": {
            "type": "string",
            "enum": [
                "NetworkAuthentication"
            ]
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        }
    },
    "required": [
        "spec",
        "apiVersion",
        "kind"
    ]
};
export class NetworkAuthentication extends Model {
    constructor(data) {
        super({
            apiVersion: NetworkAuthentication.apiVersion,
            kind: NetworkAuthentication.kind,
            ...data
        });
    }
}
NetworkAuthentication.apiVersion = "policy.linkerd.io/v1alpha1";
NetworkAuthentication.kind = "NetworkAuthentication";
NetworkAuthentication.is = createTypeMetaGuard(NetworkAuthentication);
setSchema(NetworkAuthentication, schemaId, () => {
    addSchema();
    register(schemaId, schema);
});
