"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Server = void 0;
const IoK8sApimachineryPkgApisMetaV1ObjectMeta_1 = require("@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta");
const base_1 = require("@kubernetes-models/base");
const validate_1 = require("@kubernetes-models/validate");
const schemaId = "policy.linkerd.io.v1alpha1.Server";
const schema = {
    "type": "object",
    "properties": {
        "spec": {
            "type": "object",
            "required": [
                "podSelector",
                "port"
            ],
            "properties": {
                "podSelector": {
                    "type": "object",
                    "oneOf": [
                        {
                            "required": [
                                "matchExpressions"
                            ]
                        },
                        {
                            "required": [
                                "matchLabels"
                            ]
                        }
                    ],
                    "properties": {
                        "matchLabels": {
                            "type": "object",
                            "properties": {},
                            "nullable": true
                        },
                        "matchExpressions": {
                            "type": "array",
                            "items": {
                                "type": "object",
                                "required": [
                                    "key",
                                    "operator"
                                ],
                                "properties": {
                                    "key": {
                                        "type": "string"
                                    },
                                    "operator": {
                                        "type": "string",
                                        "enum": [
                                            "In",
                                            "NotIn",
                                            "Exists",
                                            "DoesNotExist"
                                        ]
                                    },
                                    "values": {
                                        "type": "array",
                                        "items": {
                                            "type": "string"
                                        },
                                        "nullable": true
                                    }
                                }
                            },
                            "nullable": true
                        }
                    }
                },
                "port": {},
                "proxyProtocol": {
                    "type": "string",
                    "default": "unknown",
                    "nullable": true
                }
            }
        },
        "apiVersion": {
            "type": "string",
            "enum": [
                "policy.linkerd.io/v1alpha1"
            ]
        },
        "kind": {
            "type": "string",
            "enum": [
                "Server"
            ]
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        }
    },
    "required": [
        "spec",
        "apiVersion",
        "kind"
    ]
};
class Server extends base_1.Model {
    constructor(data) {
        super({
            apiVersion: Server.apiVersion,
            kind: Server.kind,
            ...data
        });
    }
}
exports.Server = Server;
Server.apiVersion = "policy.linkerd.io/v1alpha1";
Server.kind = "Server";
Server.is = (0, base_1.createTypeMetaGuard)(Server);
(0, base_1.setSchema)(Server, schemaId, () => {
    (0, IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.addSchema)();
    (0, validate_1.register)(schemaId, schema);
});
